## ocsigenserver 2.0.3a

=== Makefile ===
include Makefile.config

### Building

.PHONY: all byte opt doc

all:
	${MAKE} -C src all

byte:
	${MAKE} -C src byte

opt:
	${MAKE} -C src opt

doc:
	$(MAKE) -C doc

### Testing and debugging : local execution and toplevel ###

.PHONY: run.local run.opt.local top

run.local: byte
	CAML_LD_LIBRARY_PATH=src/server src/server/${PROJECTNAME} -c local/etc/${PROJECTNAME}.conf

run.opt.local: opt
	CAML_LD_LIBRARY_PATH=src/server src/server/${PROJECTNAME}.opt -c local/etc/${PROJECTNAME}.conf

top:
	cd src/server && ${MAKE} top

### Cleaning ###

clean: clean.local
	${MAKE} -C src clean

clean.local:
	-rm -f $(PROJECTNAME)-*.tar.gz

distclean: clean.local
	${MAKE} -C src distclean
	-make -C doc clean
	-rm Makefile.config
	-rm -f *~ \#* .\#*

### Installation ####

.PHONY: install partialinstall reinstall uninstall purge.files install.files

install.META:
	$(MAKE) -C src install
install.META.byte:
	$(MAKE) -C src install.byte
install.META.opt:
	$(MAKE) -C src install.opt

reinstall: uninstall install
reinstall.byte: uninstall install.byte
reinstall.opt: uninstall install.opt

install: install.META install.files
	@echo
	@echo "## Run \"make doc\" and \"make install.doc\" to build and install the ocamldoc."

install.byte: install.META.byte install.files
install.opt: install.META.opt install.files

install.files:
	 ## Command pipe
	$(INSTALL) -m 755 -d $(dir $(TEMPROOT)$(COMMANDPIPE))
	[ -p $(TEMPROOT)$(COMMANDPIPE) ] || \
	 { mkfifo $(TEMPROOT)$(COMMANDPIPE); \
	   $(CHMOD) 660 $(TEMPROOT)$(COMMANDPIPE); \
	   $(CHOWN) -R $(OCSIGENUSER):$(OCSIGENGROUP) $(TEMPROOT)$(COMMANDPIPE); }
	 ## Configuration files
	$(INSTALL) -m 755 -d $(TEMPROOT)$(CONFIGDIR)/conf.d
	${INSTALL} -m 644 ${PROJECTNAME}.conf.sample $(TEMPROOT)$(CONFIGDIR)/
	[ -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf ] || \
	  { $(INSTALL) -m 644 $(PROJECTNAME).conf.sample \
                $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf;  }
	-mv $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	 ## Log directory
	$(INSTALL) -m 644 src/files/mime.types $(TEMPROOT)$(CONFIGDIR)
	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  $(TEMPROOT)$(LOGDIR)
	 ## Static files
	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m 750 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  $(TEMPROOT)$(DATADIR)
	$(INSTALL) -m 644 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  local/var/www/*.html $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -m 644 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
	  local/var/www/ocsigenstuff/* $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -d -m 755 $(TEMPROOT)$(MANDIR)
	$(INSTALL) -m 644 src/files/${PROJECTNAME}.1 $(TEMPROOT)$(MANDIR)

uninstall:
	-make -C doc uninstall
	-rm -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf.sample
	-rm -f $(TEMPROOT)$(MANDIR)/${PROJECTNAME}.1
	-rm -f $(TEMPROOT)$(COMMANDPIPE)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)/conf.d
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(LOGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(DATADIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(MANDIR)
	-$(MAKE) -C src uninstall

purge: purge.files uninstall

purge.files:
	-rm -f $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	-rm -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf
	-rm -f $(patsubst local/var/www/ocsigenstuff/%, \
	 		  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff/%, \
	                  $(wildcard local/var/www/ocsigenstuff/*))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	-rm -f $(patsubst local/var/www/%, \
	 		  $(TEMPROOT)$(STATICPAGESDIR)/%, \
	                  $(wildcard local/var/www/*.html))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)

install.doc:
	${MAKE} -C doc install

### Install logrotate configuration files ###

.PHONY: logrotate

logrotate:
	 $(INSTALL) -m 755 -d $(TEMPROOT)/etc/logrotate.d
	 cat src/files/logrotate.in \
	     | sed s%LOGDIR%$(LOGDIR)%g \
	     | sed s%USER%$(OCSIGENUSER)%g \
	     | sed s%GROUP%$(OCSIGENGROUP)%g \
	     | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME); }

###

.PHONY: dist

VERSION := $(shell head -n 1 VERSION)
dist:
	DARCS_REPO=$(PWD) darcs dist -d $(PROJECTNAME)-$(VERSION)

###

.PHONY: depend
depend:
	${MAKE} -C src depend

=== doc/Makefile ===
include ../Makefile.config
include ../src/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

LIBS := -package lwt,tyxml,ssl \
        ${addprefix -I ../src/, baselib http server extensions }

doc: odoc

odoc:
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc -html $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)

uninstall:
	-rm -Rf $(TEMPROOT)$(DOCDIR)

clean:
	-rm -f api-html/*
	-rm -f *~ \#* .\#*

=== src/Makefile ===
include ../Makefile.config

all: metas confs
	${MAKE} -C baselib all
	${MAKE} -C http all
	${MAKE} -C server all
	${MAKE} -C extensions all

byte: metas confs
	${MAKE} -C baselib byte
	${MAKE} -C http byte
	${MAKE} -C server byte
	${MAKE} -C extensions byte

opt: metas confs
	${MAKE} -C baselib opt
	${MAKE} -C http opt
	${MAKE} -C server opt
	${MAKE} -C extensions opt

### META ###

metas: files/META files/META.${PROJECTNAME}

files/META: files/META.in ../Makefile.config ../Makefile.options Makefile
	cat $< \
	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	  > $@

files/META.${PROJECTNAME}: files/META.in ../Makefile.config ../Makefile.options Makefile
	echo directory = \"../server\" > $@
	cat $< \
	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	  | sed "s%package \"\(polytables\|commandline\|baselib\)\" (%package \"\1\" (\n  directory = \"../baselib\"%" \
	  | sed "s%package \"\(http\|cookies\)\" (%package \"\1\" (\n  directory = \"../http\"%" \
	  | sed "s%directory = \"extensions\"%directory = \"../extensions\"%" \
	  >> $@

### CONF ####

confs: ../$(PROJECTNAME).conf.sample ../local/etc/${PROJECTNAME}.conf

../$(PROJECTNAME).conf.sample: files/$(PROJECTNAME).conf.in ../Makefile.config Makefile
	cat $< \
	  | sed s%_LOGDIR_%$(LOGDIR)%g \
	  | sed s%_DATADIR_%$(DATADIR)%g \
	  | sed s%_OCSIGENUSER_%$(OCSIGENUSER)%g \
	  | sed s%_OCSIGENGROUP_%$(OCSIGENGROUP)%g \
	  | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	  | sed s%_MIMEFILE_%$(CONFIGDIR)/mime.types%g \
	  | sed s%_METADIR_%$(LIBDIR)%g \
	  | sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	  | sed s%_LIBDIR_%$(LIBDIR)%g \
	  | sed s%_EXTDIR_%$(LIBDIR)/ocsigenserver/extensions%g \
	  | sed s%_CONFIGDIR_%$(CONFIGDIR)%g \
	  | sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)%g \
	  | sed s%_EXTPACKAGENAME_%$(PROJECTNAME).ext%g \
	  > $@

../local/etc/$(PROJECTNAME).conf: files/${PROJECTNAME}.conf.in ../Makefile.config Makefile
	cat $< \
	  | sed s%80\</port\>%8080\</port\>%g \
	  | sed s%_LOGDIR_%$(SRC)/local/var/log%g \
	  | sed s%_DATADIR_%$(SRC)/local/var/lib%g \
	  | sed s%\<user\>_OCSIGENUSER_\</user\>%%g \
	  | sed s%\<group\>_OCSIGENGROUP_\</group\>%%g \
	  | sed s%_COMMANDPIPE_%$(SRC)/local/var/run/${PROJECTNAME}_command%g \
	  | sed s%_MIMEFILE_%$(SRC)/src/files/mime.types%g \
	  | sed s%_METADIR_%${LIBDIR}\"/\>\<findlib\ path=\"$(SRC)/src/files/\"/\>\<findlib\ path=\"$(SRC)/src/extensions/files/%g \
	  | sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	  | sed s%_EXTLIBDIR_%${SRC}/src/extensions/ocsipersist-dbm%g \
	  | sed s%_CONFIGDIR_%$(SRC)/local/etc/%g \
	  | sed s%_STATICPAGESDIR_%$(SRC)/local/var/www%g \
	  | sed s%_EXTPACKAGENAME_%$(PROJECTNAME).ext%g \
	  | sed s%\<\!--\ \<commandpipe%\<commandpipe%g \
	  | sed s%\</commandpipe\>\ --\>%\</commandpipe\>%g \
	  | sed s%\<\!--\ \<mimefile%\<mimefile%g \
	  | sed s%\</mimefile\>\ --\>%\</mimefile\>%g \
	  | sed s%store\ dir=\"$(SRC)/var/lib\"%store\ dir=\"$(SRC)/local/var/lib/ocsipersist\"%g \
	  > $@


### Install ###

include Makefile.filelist

VERSION := $(shell head -n 1 ../VERSION)

install: INSTALL_BIN=$(BIN) $(NATBIN)
install: INSTALL_IMPL=$(IMPL) $(NATIMPL)
install: INSTALL_PLUGINS_IMPL=$(PLUGINS_IMPL) $(PLUGINS_NATIMPL)
install: INSTALL_PLUGINS_BIN=$(PLUGINS_BIN) $(PLUGINS_NATBIN)
install: raw_install

install.byte: INSTALL_BIN=$(BIN)
install.byte: INSTALL_IMPL=$(IMPL)
install.byte: INSTALL_PLUGINS_IMPL=$(PLUGINS_IMPL)
install.byte: INSTALL_PLUGINS_BIN=$(PLUGINS_BIN)
install.byte: raw_install

install.opt: INSTALL_BIN=$(NATBIN)
install.opt: INSTALL_IMPL=$(NATIMPL)
install.opt: INSTALL_PLUGINS_IMPL=$(PLUGINS_NATIMPL)
install.opt: INSTALL_PLUGINS_BIN=$(PLUGINS_NATBIN)
install.opt: raw_install

raw_install:
	 # Server binaries
	$(INSTALL) -m 755 -d $(TEMPROOT)$(BINDIR)
	$(INSTALL) -m 755 $(INSTALL_BIN) $(TEMPROOT)$(BINDIR)/
	 # Server libraries
	$(INSTALL) -m 755 -d $(TEMPROOT)$(LIBDIR)
	$(OCAMLFIND) install $(PROJECTNAME) \
	   -destdir $(TEMPROOT)$(LIBDIR) \
	   -patch-version ${VERSION} \
	   ${INTF} $(INSTALL_IMPL) $(DOC) files/META
	 # Extensions
	$(INSTALL) -m 755 -d $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	$(INSTALL) -m 644 \
	  $(PLUGINS_INTF) $(INSTALL_PLUGINS_IMPL) $(PLUGINS_DOC) \
	  $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	[ -z "$(strip ${INSTALL_PLUGINS_BIN})" ] || \
	  $(INSTALL) -m 755 $(INSTALL_PLUGINS_BIN) \
	  $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/

uninstall:
	 # Extensions
	-rm -r $(TEMPROOT)${LIBDIR}/${PROJECTNAME}/extensions/
	 # Server libraries
	-$(OCAMLFIND) remove ${PROJECTNAME} -destdir $(TEMPROOT)${LIBDIR}
	 # Server binaries
	-rm -r $(addprefix $(TEMPROOT)$(BINDIR)/,$(notdir ${BIN} ${NATBIN}))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(BINDIR)

reinstall: uninstall install

###

clean: clean.local
	${MAKE} -C baselib clean
	${MAKE} -C http clean
	${MAKE} -C server clean
	${MAKE} -C extensions clean

clean.local:
	-rm -f ../${PROJECTNAME}.conf.sample
	-rm -f ../${PROJECTNAME}.conf.opt.sample
	-rm -f ../${PROJECTNAME}.conf.local
	-rm -f ../${PROJECTNAME}.conf.opt.local
	-rm -f files/META files/META.${PROJECTNAME}

distclean: clean.local
	${MAKE} -C baselib distclean
	${MAKE} -C http distclean
	${MAKE} -C server distclean
	${MAKE} -C extensions distclean
	-rm -f *~ \#* .\#*
	-cd files; rm -f *~ \#* .\#*
	-rm -fr ../local/var/log/*.log
	-rm -fr ../local/var/lib/ocsidb
	-rm -fr ../local/etc/${PROJECTNAME}.conf
	-rm -fr ../local/etc/${PROJECTNAME}.conf.opt

depend:
	${MAKE} -C baselib depend
	${MAKE} -C http depend
	${MAKE} -C server depend
	${MAKE} -C extensions depend

=== debian/changelog ===
ocsigenserver (2.0.3a-1) unstable; urgency=low

  * New upstream release
    - the server and Eliom have been separated upstream; this package
      contains only the server (Eliom will be packaged separately)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 01 Feb 2012 21:00:42 +0100

ocsigen (1.3.4-2) unstable; urgency=low

  * Fix wrong decoding of + in URL paths (cherry-picked from upstream)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 12 Jul 2011 20:38:51 +0200

ocsigen (1.3.4-1) unstable; urgency=low

  * New upstream release
  * Touch .cmi files after installing the .mli files (Closes: #587300)
  * Bump Standards-Version to 3.9.2 (no changes)

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Sun, 29 May 2011 13:54:41 +0200

ocsigen (1.3.3-3) unstable; urgency=low

  * Do not try to install native objects on non-natdynlink architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Apr 2011 23:47:16 +0200

ocsigen (1.3.3-2) unstable; urgency=low

  * Add missing dependencies to ocsigen: libocsigen-xhtml-ocaml-dev and
    liblwt-ssl-ocaml-dev (Closes: #613372)
  * Do not compile native code version if there is no natdynlink
  * Bump debhelper compat level to 8
  * Bump Standards-Version to 3.9.1

 -- Stéphane Glondu <glondu@debian.org>  Tue, 15 Feb 2011 19:01:11 +0100

ocsigen (1.3.3-1) unstable; urgency=low

  * New upstream release
  * Move META file to libocsigen-ocaml

 -- Stéphane Glondu <glondu@debian.org>  Sun, 13 Jun 2010 11:44:07 +0200

ocsigen (1.3.2-1) unstable; urgency=low

  * New upstream release
    - the web server should now be insensitive to the net.ipv6.bindv6only
      sysctl setting (Closes: #578216)
    - add ocsigen.xhtml* compatibility packages (Closes: #579689)
    - remove all patches (committed upstream)
    - bump build-dependency to lwt to 2.1.0
  * Remove Stefano from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Fri, 30 Apr 2010 08:39:59 +0200

ocsigen (1.3.0-4) unstable; urgency=low

  * Fix FTBFS on hppa:
    - add 0002-Do-not-compile-dbm-test-with-custom.patch
  * Fix "directory" variable in META.ocsigen_ext

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Mar 2010 23:02:28 +0100

ocsigen (1.3.0-3) unstable; urgency=low

  * Split out libocsigen-xhtml-ocaml-dev (Closes: #574887)
    - add 0001-Split-out-ocsigen_xhtml-findlib-package.patch
  * Put dynamically loaded plugins into libocsigen-ocaml
  * Fix symbolic links shipped by libocsigen-ocaml-doc

 -- Stéphane Glondu <glondu@debian.org>  Mon, 22 Mar 2010 00:52:03 +0100

ocsigen (1.3.0-2) unstable; urgency=low

  * Upload to unstable
  * This version breaks nurpawiki (<< 1.2.3-4~) because of API changes

 -- Stéphane Glondu <glondu@debian.org>  Mon, 15 Mar 2010 16:13:10 +0100

ocsigen (1.3.0-1) experimental; urgency=low

  * New upstream release
    - add libobrowser-ocaml-dev to Build-Depends
  * Switch source package format to 3.0 (quilt)
  * Bump Standards-Version to 3.8.4 (no changes)
  * Add dependency to remote_fs in initscript
  * Compile the doc only when libocsigen-ocaml-doc is being built

 -- Stéphane Glondu <glondu@debian.org>  Sun, 07 Mar 2010 14:05:31 +0100

ocsigen (1.2.2-1) unstable; urgency=low

  * New upstream release
  * Major overhaul of binary packages: libocsigen-ocaml{,-dev,-doc} is now
    treated as a regular library (Closes: #517303), without dependency to
    the web server itself; ocsigen-dev is kept as a metapackage that
    depends on the web server
  * Switch packaging to dh-ocaml 0.9
  * Handle /var/log/ocsigen in maintainer scripts:
    - create an empty log when installing (Closes: #550324)
    - remove log files on purging (policy 10.8)
  * Upload to unstable (Closes: #551236)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 21 Oct 2009 18:19:59 +0200

ocsigen (1.2.1-1) experimental; urgency=low

  * New upstream release:
    - remove all patches (merged upstream)
  * Update watch file
  * Change dependency to liblwt-ocaml in ocsigen

 -- Stéphane Glondu <glondu@debian.org>  Sat, 26 Sep 2009 13:56:22 +0200

ocsigen (1.2.0-3+lwt.1) experimental; urgency=low

  * Update my e-mail address and remove DMUA
  * Update dependencies to lwt

 -- Stéphane Glondu <glondu@debian.org>  Sun, 30 Aug 2009 20:17:39 +0200

ocsigen (1.2.0-3+lwt.0) experimental; urgency=low

  * Build with experimental lwt:
    - add patches Fix-ocsipersist-dbm-Makefile and Adapt-for-lwt-2
    - add versioned (build-)dependency

 -- Stephane Glondu <steph@glondu.net>  Fri, 21 Aug 2009 10:51:52 +0200

ocsigen (1.2.0-3) unstable; urgency=low

  * Changes in dependencies of the ocsigen binary package:
    - add lib{ssl,pcre,ocamlnet}-ocaml (Closes: #536865)
    - change lib{sqlite3,cryptokit,zip}-ocaml-dev to their non-dev
      counterparts, and add versioned dependencies
  * Update Standards-Version to 3.8.3 (no changes)

 -- Stephane Glondu <steph@glondu.net>  Fri, 21 Aug 2009 10:35:02 +0200

ocsigen (1.2.0-2) unstable; urgency=low

  * Fix build on non-native architectures

 -- Stephane Glondu <steph@glondu.net>  Thu, 02 Jul 2009 10:02:08 +0200

ocsigen (1.2.0-1) unstable; urgency=low

  * New upstream release:
    - new patches:
      + fix typo in configure script
      + fix build with pcre-ocaml 6.0.0
    - add dependency on quilt
    - add README.source file
  * Enable OCamlDuce support
  * Enable native code support
  * Add versioned dependency on libpcre-ocaml-dev
  * Install sample configuration files with examples
  * Update Standards-Version to 3.8.2
  * Add versioned dependencies to ease OCaml 3.11.1 transition

 -- Stephane Glondu <steph@glondu.net>  Wed, 01 Jul 2009 21:49:21 +0200

ocsigen (1.1.0-2) unstable; urgency=low

  [ Samuel Mimram ]
  * Use dh-ocaml predefined variables in rules.

  [ Stephane Glondu ]
  * Add Provides: httpd, httpd-cgi to ocsigen binary package
  * Update Build-Depends for OCaml 3.11.0 transition
  * Force -custom when linking ocsigen
  * Use more recent features of debhelper 7
  * Install sources of examples in ocsigen-doc


=== debian/control ===
Source: ocsigenserver
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Samuel Mimram <smimram@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-findlib (>= 1.2.5),
 liblwt-ssl-ocaml-dev (>= 2.1.1),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libssl-ocaml-dev (>= 0.4.3-3~),
 libgdbm-dev,
 libsqlite3-ocaml-dev (>= 1.5.6-3~),
 libzip-ocaml-dev (>= 1.04-6~),
 libcryptokit-ocaml-dev (>= 1.3-14~),
 libtyxml-ocaml-dev,
 dh-ocaml (>= 0.9.5~)
Standards-Version: 3.9.2
Homepage: http://ocsigen.org/ocsigenserver/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocsigenserver.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git

Package: ocsigenserver
Section: httpd
Architecture: any
Depends: adduser, psmisc, procps,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocsigenserver-doc
Provides: httpd, httpd-cgi
Description: web server of the Ocsigen project
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.

Package: libocsigenserver-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: web server of the Ocsigen project (runtime libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains runtime libraries.

Package: libocsigenserver-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 libgdbm-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocsigenserver-doc
Description: web server of the Ocsigen project (dev libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains development libraries.

Package: ocsigenserver-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: ocsigenserver, libocsigenserver-ocaml-dev
Description: web server of the Ocsigen project (documentation)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

## ocsigenserver 2.0.4

=== Makefile ===
--- 
+++ 
@@ -93,7 +93,8 @@
 	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
 	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
 	$(INSTALL) -m 644 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
-	  local/var/www/ocsigenstuff/* $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
+	  local/var/www/ocsigenstuff/*.png local/var/www/ocsigenstuff/*.css \
+	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
 	$(INSTALL) -d -m 755 $(TEMPROOT)$(MANDIR)
 	$(INSTALL) -m 644 src/files/${PROJECTNAME}.1 $(TEMPROOT)$(MANDIR)

=== src/baselib/Makefile ===
include ../../Makefile.config

LIBS     := -package lwt.unix,netstring,cryptokit,findlib,tyxml,lwt.syntax,${LWT_EXTRA_PACKAGE}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := ocsigen_pervasives.ml     \
	 ocsigen_cache.ml          \
         ocsigen_config.ml         \
	 ocsigen_commandline.ml    \
	 ocsigen_messages.ml       \
	 dynlink_wrapper.ml        \
         ocsigen_loader.ml         \
	 ocsigen_stream.ml         \

INTF_NOP4 := ocsigen_pervasives.mli

PREDEP := ocsigen_config.ml dynlink_wrapper.ml

byte:: baselib.cma
opt:: baselib.cmxa

baselib.cma:
	${OCAMLC} -a -o $@ $^
baselib.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

baselib.cma: $(FILES:.ml=.cmo)

## Ocsigen_config ##

ifeq "$(NATDYNLINK)" "YES"
  NATIVECODE_RUNTIME_DETECT=Dynlink.is_native
else
  NATIVECODE_RUNTIME_DETECT=false
endif

ifeq "$(PREEMPTIVE)" "YES"
  PREEMTIMPLEM=Lwt_preemptive
else
  PREEMTIMPLEM=Fake_preempt
endif

VERSION := $(shell head -n 1 ../../VERSION)

ocsigen_config.ml: ocsigen_config.ml.in ../../Makefile.config ../../Makefile.options ../../VERSION
	cat ocsigen_config.ml.in \
	| sed s%0000000000000000%${VERSION}% \
	| sed s%_WARNING_%"Warning: this file has been generated from ocsigen_config.ml.in - DO NOT MODIFY MANUALLY!"% \
	| sed s%_LOGDIR_%$(LOGDIR)% \
	| sed s%_DATADIR_%$(DATADIR)%g \
	| sed s%_BINDIR_%$(BINDIR)%g \
	| sed s%_EXTDIR_%$(LIBDIR)/${PROJECTNAME}/extensions%g \
	| sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)% \
	| sed s%_UP_%$(UPLOADDIR)%g \
	| sed s%_OCSIGENUSER_%$(OCSIGENUSER)%g \
	| sed s%_OCSIGENGROUP_%$(OCSIGENGROUP)%g \
	| sed s%_PROJECTNAME_%$(PROJECTNAME)%g \
	| sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	| sed s%_CONFIGDIR_%$(CONFIGDIR)% \
	| sed s%_PREEMTIMPLEM_%$(PREEMTIMPLEM)% \
	| sed s%_ISNATIVE_%$(NATIVECODE_RUNTIME_DETECT)%g \
	| sed "s%_DEPS_%$(INITPACKAGE)%g" \
	> ocsigen_config.ml

## Dynlink_wrapper ##

ifeq "$(NATDYNLINK)" "YES"
dynlink_wrapper.ml:
	ln -s dynlink_wrapper.natdynlink.ml $@
dynlink_wrapper.cmo dynlink_wrapper.cmx: dynlink_wrapper.natdynlink.ml
else
dynlink_wrapper.ml:
	ln -s dynlink_wrapper.nonatdynlink.ml $@
dynlink_wrapper.cmo dynlink_wrapper.cmx: dynlink_wrapper.nonatdynlink.ml
endif

### Command line ###

byte:: parsecommandline.cma donotparsecommandline.cma
opt:: parsecommandline.cmxa donotparsecommandline.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: parsecommandline.cmxs donotparsecommandline.cmxs
endif

parsecommandline.cma: commandline/ocsigen_getcommandline.cmo
	$(OCAMLC) -a -o $@ $^

donotparsecommandline.cma: nocommandline/ocsigen_getcommandline.cmo
	$(OCAMLC) -a -o $@ $^

parsecommandline.cmxa: commandline/ocsigen_getcommandline.cmx
	$(OCAMLOPT) -a -o $@ $^

donotparsecommandline.cmxa: nocommandline/ocsigen_getcommandline.cmx
	$(OCAMLOPT) -a -o $@ $^

### Polytables ###

byte:: polytables.cma
opt:: polytables.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: polytables.cmxs
endif

polytables.cma: polytables.cmo
	$(OCAMLC) -a -o $@ $<

polytables.cmxa: polytables.cmx
	$(OCAMLOPT) -a -o $@ $<

##########

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${INTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
	-cd commandline; rm -f *.cm[iox]* *.annot *.o
	-cd nocommandline; rm -f *.cm[iox]* *.annot *.o

distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} -syntax camlp4o $(filter-out ${INTF_NOP4},$(wildcard *.mli)) *.ml > .depend
	$(OCAMLDEP) ${LIBS} ${INTF_NOP4} >> .depend

FORCE:
-include .depend

=== debian/changelog ===
ocsigenserver (2.0.4-1) unstable; urgency=low

  * New upstream release
  * Fix FTBFS with bash as /bin/sh

 -- Stéphane Glondu <glondu@debian.org>  Sat, 17 Mar 2012 11:42:51 +0100

## ocsigenserver 2.1

=== Makefile ===
--- 
+++ 
@@ -138,7 +138,7 @@
 	     | sed s%USER%$(OCSIGENUSER)%g \
 	     | sed s%GROUP%$(OCSIGENGROUP)%g \
 	     | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
-	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME); }
+	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME) }
 
 ###

=== debian/changelog ===
ocsigenserver (2.1-1) unstable; urgency=low

  * New upstream release (Closes: #676750)
  * Use format 1.0 in debian/copyright
  * Bump Standards-Version to 3.9.3

 -- Stéphane Glondu <glondu@debian.org>  Sat, 09 Jun 2012 10:54:47 +0200

=== debian/control ===
--- 
+++ 
@@ -19,9 +19,9 @@
  libsqlite3-ocaml-dev (>= 1.5.6-3~),
  libzip-ocaml-dev (>= 1.04-6~),
  libcryptokit-ocaml-dev (>= 1.3-14~),
- libtyxml-ocaml-dev,
+ libtyxml-ocaml-dev (>= 2.1),
  dh-ocaml (>= 0.9.5~)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://ocsigen.org/ocsigenserver/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocsigenserver.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git

## ocsigenserver 2.2.0

=== Makefile ===
--- 
+++ 
@@ -65,38 +65,63 @@
 install.byte: install.META.byte install.files
 install.opt: install.META.opt install.files
 
+# BB If install is not run by root but OCSIGENUSER, OCSIGENGROUP is somebody
+# BB different, make files universally accessible, we cannot chown.
+INSTALL_CAN_PUT_PERMISSIONS=yes
+INSTALL_USER_GROUP=-o $(OCSIGENUSER) -g $(OCSIGENGROUP)
+INSTALL_MOD_660=660
+INSTALL_MOD_644=644
+INSTALL_MOD_755=755
+INSTALL_MOD_770=770
+INSTALL_MOD_750=750
+ifneq ($(shell id -u), 0)
+  ifneq ($(OCSIGENUSER), $(USERNAME))
+    INSTALL_CAN_PUT_PERMISSIONS=no
+  endif
+  ifneq ($(shell groups ${USERNAME}|grep -q ${OCSIGENGROUP}; echo $$?), 0)
+    INSTALL_CAN_PUT_PERMISSIONS=no
+  endif
+endif
+ifeq ($(INSTALL_CAN_PUT_PERMISSIONS), no)
+    INSTALL_USER_GROUP=
+    INSTALL_MOD_660=666
+    INSTALL_MOD_644=666
+    INSTALL_MOD_755=777
+    INSTALL_MOD_770=777
+    INSTALL_MOD_750=777
+endif
+
 install.files:
+	@echo INSTALL_CAN_PUT_PERMISSIONS: ${INSTALL_CAN_PUT_PERMISSIONS}
 	 ## Command pipe
-	$(INSTALL) -m 755 -d $(dir $(TEMPROOT)$(COMMANDPIPE))
+	$(INSTALL) -m ${INSTALL_MOD_755} -d $(dir $(TEMPROOT)$(COMMANDPIPE))
 	[ -p $(TEMPROOT)$(COMMANDPIPE) ] || \
-	 { mkfifo $(TEMPROOT)$(COMMANDPIPE); \
-	   $(CHMOD) 660 $(TEMPROOT)$(COMMANDPIPE); \
-	   $(CHOWN) -R $(OCSIGENUSER):$(OCSIGENGROUP) $(TEMPROOT)$(COMMANDPIPE); }
+	 { mkfifo -m ${INSTALL_MOD_660} $(TEMPROOT)$(COMMANDPIPE); \
+	   if [ "${INSTALL_CAN_PUT_PERMISSIONS}" = yes ]; \
+	     then $(CHOWN) -R $(OCSIGENUSER):$(OCSIGENGROUP) $(TEMPROOT)$(COMMANDPIPE); \
+	   fi; }
 	 ## Configuration files
-	$(INSTALL) -m 755 -d $(TEMPROOT)$(CONFIGDIR)/conf.d
-	${INSTALL} -m 644 ${PROJECTNAME}.conf.sample $(TEMPROOT)$(CONFIGDIR)/
+	$(INSTALL) -m ${INSTALL_MOD_755} -d $(TEMPROOT)$(CONFIGDIR)/conf.d
+	${INSTALL} -m ${INSTALL_MOD_644} ${PROJECTNAME}.conf.sample $(TEMPROOT)$(CONFIGDIR)/
 	[ -f $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf ] || \
-	  { $(INSTALL) -m 644 $(PROJECTNAME).conf.sample \
+	  { $(INSTALL) -m ${INSTALL_MOD_644} $(PROJECTNAME).conf.sample \
                 $(TEMPROOT)$(CONFIGDIR)/$(PROJECTNAME).conf;  }
 	-mv $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
 	 ## Log directory
-	$(INSTALL) -m 644 src/files/mime.types $(TEMPROOT)$(CONFIGDIR)
-	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
-	  $(TEMPROOT)$(LOGDIR)
+	$(INSTALL) -m ${INSTALL_MOD_644} src/files/mime.types $(TEMPROOT)$(CONFIGDIR)
+	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(LOGDIR)
 	 ## Static files
-	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
-	  $(TEMPROOT)$(STATICPAGESDIR)
-	$(INSTALL) -d -m 750 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
-	  $(TEMPROOT)$(DATADIR)
-	$(INSTALL) -m 644 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
+	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(STATICPAGESDIR)
+	$(INSTALL) -d -m ${INSTALL_MOD_750} ${INSTALL_USER_GROUP} $(TEMPROOT)$(DATADIR)
+	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
 	  local/var/www/*.html $(TEMPROOT)$(STATICPAGESDIR)
-	$(INSTALL) -d -m 755 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
+	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} \
 	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
-	$(INSTALL) -m 644 -o ${OCSIGENUSER} -g ${OCSIGENGROUP} \
+	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
 	  local/var/www/ocsigenstuff/*.png local/var/www/ocsigenstuff/*.css \
 	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
-	$(INSTALL) -d -m 755 $(TEMPROOT)$(MANDIR)
-	$(INSTALL) -m 644 src/files/${PROJECTNAME}.1 $(TEMPROOT)$(MANDIR)
+	$(INSTALL) -d -m ${INSTALL_MOD_755} $(TEMPROOT)$(MANDIR)
+	$(INSTALL) -m ${INSTALL_MOD_644} src/files/${PROJECTNAME}.1 $(TEMPROOT)$(MANDIR)
 
 uninstall:
 	-make -C doc uninstall
@@ -138,7 +163,7 @@
 	     | sed s%USER%$(OCSIGENUSER)%g \
 	     | sed s%GROUP%$(OCSIGENGROUP)%g \
 	     | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
-	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME) }
+	     > $(TEMPROOT)/etc/logrotate.d/$(PROJECTNAME)
 
 ###

=== doc/Makefile ===
include ../Makefile.config
include ../src/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc
ODOC_WIKI := odoc_wiki.cma

LIBS := -package lwt,tyxml,ssl \
        ${addprefix -I ../src/, baselib http server extensions }

doc: api-html/index.html
api-html/index.html: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc -html $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

wikidoc: api-wiki/index.wiki
api-wiki/index.wiki: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-wiki
	$(OCAMLDOC) ${LIBS} -d api-wiki -intro indexdoc -colorize-code \
	   -i $(shell ocamlfind query wikidoc) -g ${ODOC_WIKI} \
	   $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)

uninstall:
	-rm -Rf $(TEMPROOT)$(DOCDIR)

clean:
	-rm -f api-html/* api-wiki/*
	-rm -f *~ \#* .\#*

=== src/Makefile ===
--- 
+++ 
@@ -27,6 +27,7 @@
 	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
 	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
 	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
+	  | sed s/%%BASEDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${BASE_PACKAGE})/g \
 	  > $@
 
 files/META.${PROJECTNAME}: files/META.in ../Makefile.config ../Makefile.options Makefile
@@ -35,6 +36,7 @@
 	  | sed s/%%CAMLZIPNAME%%/$(CAMLZIPNAME)/ \
 	  | sed s/%%NAME%%/$(PROJECTNAME)/g \
 	  | sed s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
+	  | sed s/%%BASEDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${BASE_PACKAGE})/g \
 	  | sed "s%package \"\(polytables\|commandline\|baselib\)\" (%package \"\1\" (\n  directory = \"../baselib\"%" \
 	  | sed "s%package \"\(http\|cookies\)\" (%package \"\1\" (\n  directory = \"../http\"%" \
 	  | sed "s%directory = \"extensions\"%directory = \"../extensions\"%" \

=== src/baselib/Makefile ===
--- 
+++ 
@@ -10,7 +10,8 @@
 
 ### Common files ###
 
-FILES := ocsigen_pervasives.ml     \
+FILES := ocsigen_lib_base.ml       \
+	 ocsigen_lib.ml            \
 	 ocsigen_cache.ml          \
          ocsigen_config.ml         \
 	 ocsigen_commandline.ml    \
@@ -19,7 +20,7 @@
          ocsigen_loader.ml         \
 	 ocsigen_stream.ml         \
 
-INTF_NOP4 := ocsigen_pervasives.mli
+INTF_NOP4 := ocsigen_lib_base.mli ocsigen_lib.mli
 
 PREDEP := ocsigen_config.ml dynlink_wrapper.ml

=== src/extensions/Makefile ===
include ../../Makefile.config

PACKAGE  := lwt.unix     \
	    lwt.ssl      \
	    lwt.react    \
            netstring    \
	    tyxml.parser \

LIBS     := -I ../baselib -I ../http -I ../server ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Extensions ###

FILES := staticmod.ml           \
	 cgimod.ml              \
	 redirectmod.ml         \
	 revproxy.ml            \
	 extensiontemplate.ml   \
         accesscontrol.ml       \
         userconf.ml            \
	 outputfilter.ml        \
	 authbasic.ml           \
	 rewritemod.ml          \
	 extendconfiguration.ml \
         ocsigen_comet.ml       \
         cors.ml                \

ifeq "$(CAMLZIP)" "YES"
FILES += deflatemod.ml
deflatemod.cmo deflatemod.cmx: LIBS+=-package ${CAMLZIPNAME}
endif

byte:: ${FILES:.ml=.cmo}
opt:: ${FILES:.ml=.cmx}
ifeq "$(NATDYNLINK)" "YES"
opt:: ${FILES:.ml=.cmxs}
endif

### SQLite ###

ifeq "$(OCSIPERSISTSQLITE)" "YES"
byte::
	$(MAKE) -C ocsipersist-sqlite byte
opt::
	$(MAKE) -C ocsipersist-sqlite opt
endif

### DBM ####

ifeq "$(OCSIPERSISTDBM)" "YES"
byte::
	$(MAKE) -C ocsipersist-dbm byte
opt::
	$(MAKE) -C ocsipersist-dbm opt
endif

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmx
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean: clean.local
	${MAKE} -C ocsipersist-dbm clean
	${MAKE} -C ocsipersist-sqlite clean
clean.local:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean.local
	-rm -f *~ \#* .\#*
	${MAKE} -C ocsipersist-dbm distclean
	${MAKE} -C ocsipersist-sqlite distclean

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend
	${MAKE} -C ocsipersist-dbm depend
	${MAKE} -C ocsipersist-sqlite depend

FORCE:
-include .depend

=== src/http/Makefile ===
include ../../Makefile.config

LIBS     := -package netstring,lwt.ssl,tyxml -I ../baselib
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := multipart.ml            \
	 http_headers.ml         \
	 ocsigen_cookies.ml      \
         ocsigen_http_frame.ml   \
	 ocsigen_headers.ml      \
	 http_lexer.ml	         \
         framepp.ml              \
	 ocsigen_http_com.ml     \
	 ocsigen_charset_mime.ml \
         ocsigen_senders.ml      \

PREDEP := http_lexer.ml   \

byte: http.cma
opt: http.cmxa

http.cma: $(FILES:.ml=.cmo)
	${OCAMLC} -a -o $@ $^
http.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

##########

%.ml: %.mll
	$(OCAMLLEX) $<
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== src/server/Makefile ===
include ../../Makefile.config

all: byte opt

PACKAGE  := ${SERVER_PACKAGE} ${SERVER_SYNTAX} ## See ../../Makefile.options
LIBS     := -I ../baselib -I ../http ${addprefix -package ,${PACKAGE}} -I .
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

### Common files ###

FILES := ocsigen_extensions.ml  \
         ocsigen_range.ml       \
         ocsigen_parseconfig.ml \
         ocsigen_http_client.ml \
         ocsigen_local_files.ml  \
         ocsigen_server.ml      \


byte:: ${PROJECTNAME}.cma
opt:: ${PROJECTNAME}.cmxa

${PROJECTNAME}.cma: $(FILES:.ml=.cmo)
	${OCAMLC} -a -o $@ $^
${PROJECTNAME}.cmxa: $(FILES:.ml=.cmx)
	${OCAMLOPT} -a -o $@ $^

### Server ###

byte:: ${PROJECTNAME}
opt:: ${PROJECTNAME}.opt

ifdef DONOTPARSECOMMANDLINE
PARSECOMMANDLINE := ../baselib/donotparsecommandline.cma
else
PARSECOMMANDLINE := ../baselib/parsecommandline.cma
endif

SERVERLIBS := ${PARSECOMMANDLINE}       \
              ../baselib/baselib.cma    \
	      ../baselib/polytables.cma \
	      ../http/http.cma          \
	      ${PROJECTNAME}.cma         \

SERVEROBJS := server_main.cmo

${PROJECTNAME}: ${SERVERLIBS} ${SERVEROBJS}
	${OCAMLC} -o $@ -linkpkg -linkall ${THREAD} ${LIBS} $^
${PROJECTNAME}.opt: ${SERVERLIBS:.cma=.cmxa} ${SERVEROBJS:.cmo=.cmx}
	${OCAMLOPT} -o $@ -linkpkg -linkall ${THREAD} ${LIBS} $^

### Toplevel ####

top: servertop
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${RLWRAP} ./servertop

servertop: ${SERVERLIBS}
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${OCAMLFIND} ocamlmktop \
	   -o $@ -linkall -linkpkg ${THREAD} ${LIBS} $^

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<
%.o: %.c
	$(OCAMLC) -c $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
	-rm -r ${PROJECTNAME} ${PROJECTNAME}.opt
	-rm -f servertop
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== src/extensions/ocsipersist-dbm/Makefile ===
include ../../../Makefile.config

PACKAGE  := ${LWT_EXTRA_PACKAGE} \
	    lwt.unix     \
	    tyxml.parser \
	    dbm          \

LIBS     := -I ../../baselib -I ../../http -I ../../server \
	    ${addprefix -package ,${PACKAGE}}
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep

all: byte opt

###

byte:: ocsipersist-dbm.cma
opt:: ocsipersist-dbm.cmxa
ifeq "$(NATDYNLINK)" "YES"
opt:: ocsipersist-dbm.cmxs
endif

PREDEP := ocsipersist.mli

ocsipersist-dbm.cma: ocsipersist.cmo
	$(OCAMLC) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ..

ocsipersist-dbm.cmxa: ocsipersist.cmx
	$(OCAMLOPT) -a -o $@ $^
	cp ocsipersist.cmi ..
	cp $@ ${patsubst %.cmxa,%.a,$@} ..

ocsipersist-dbm.cmxs: ocsipersist-dbm.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $^
	cp $@ ..

ocsipersist.mli:
	ln -s ../ocsipersist.mli .

###

byte:: ocsidbm
opt:: ocsidbm.opt

ocsidbm: ocsidbm.cmo
	$(OCAMLC) -linkpkg -o $@ ${LIBS} $^

ocsidbm.opt: ocsidbm.cmx
	$(OCAMLOPT) -linkpkg -o $@ ${LIBS} $^

##########

%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<
%.cmo: %.ml
	$(OCAMLC) ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) ${LIBS} -c $<
%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${PREDEP}
	-rm -f ocsidbm ocsidbm.opt
distclean: clean
	-rm -f *~ \#* .\#*

## Dependencies

depend: ${PREDEP}
	$(OCAMLDEP) ${LIBS} *.mli *.ml > .depend

FORCE:
-include .depend

=== debian/changelog ===
ocsigenserver (2.2.0-3) unstable; urgency=low

  * Upload to unstable (Closes: #724168)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Dec 2013 09:34:45 +0100

ocsigenserver (2.2.0-2) experimental; urgency=low

  * debian/patches:
    + Fix compilation with ocamlnet 3.6.5 (addition of netstring-pcre)
  * Compile with OCaml >= 4.01
  * Drop ocsipersist-dbm (because of OCaml >= 4)
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Sun, 10 Nov 2013 16:48:10 +0100

ocsigenserver (2.2.0-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Thu, 09 May 2013 23:11:55 +0200

ocsigenserver (2.2-2) experimental; urgency=low

  * Bump versions in Build-Depends to use experimental packages

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2012 11:00:21 +0100

ocsigenserver (2.2-1) experimental; urgency=low

  * New upstream release
    - remove patch (merged upstream)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 06 Dec 2012 23:29:42 +0100

=== debian/control ===
--- 
+++ 
@@ -8,23 +8,22 @@
  Nicolas Dandrimont <nicolas.dandrimont@crans.org>
 Build-Depends:
  debhelper (>= 8),
- ocaml-nox (>= 3.11.1-3~),
+ ocaml-nox (>= 4.01),
  camlp4-extra,
- ocaml-findlib (>= 1.2.5),
- liblwt-ssl-ocaml-dev (>= 2.1.1),
- libocamlnet-ocaml-dev (>= 2.2.9-7~),
+ ocaml-findlib (>= 1.4),
+ liblwt-ssl-ocaml-dev (>= 2.4.2),
+ libocamlnet-ocaml-dev (>= 3.6.5),
  libpcre-ocaml-dev (>= 6.0.1-2~),
  libssl-ocaml-dev (>= 0.4.3-3~),
- libgdbm-dev,
  libsqlite3-ocaml-dev (>= 1.5.6-3~),
  libzip-ocaml-dev (>= 1.04-6~),
  libcryptokit-ocaml-dev (>= 1.3-14~),
- libtyxml-ocaml-dev (>= 2.1),
+ libtyxml-ocaml-dev (>= 2.2.0),
  dh-ocaml (>= 0.9.5~)
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://ocsigen.org/ocsigenserver/
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocsigenserver.git
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocsigenserver.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/ocsigenserver.git
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/ocsigenserver.git
 
 Package: ocsigenserver
 Section: httpd

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/,dversionmangle=s/\+dfsg\d*$//" \
http://ocsigen.org/download/ocsigenserver-(.*)\.tar\.gz

## ocsigenserver 2.4.0

=== Makefile ===
--- 
+++ 
@@ -21,10 +21,10 @@
 .PHONY: run.local run.opt.local top
 
 run.local: byte
-	CAML_LD_LIBRARY_PATH=src/server src/server/${PROJECTNAME} -c local/etc/${PROJECTNAME}.conf
+	CAML_LD_LIBRARY_PATH=src/server:$(CAML_LD_LIBRARY_PATH) src/server/${PROJECTNAME} -c local/etc/${PROJECTNAME}.conf
 
 run.opt.local: opt
-	CAML_LD_LIBRARY_PATH=src/server src/server/${PROJECTNAME}.opt -c local/etc/${PROJECTNAME}.conf
+	CAML_LD_LIBRARY_PATH=src/server:$(CAML_LD_LIBRARY_PATH) src/server/${PROJECTNAME}.opt -c local/etc/${PROJECTNAME}.conf
 
 top:
 	cd src/server && ${MAKE} top

=== doc/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 OCAMLDOC := ${OCAMLFIND} ocamldoc
 ODOC_WIKI := odoc_wiki.cma
 
-LIBS := -package lwt,tyxml,ssl \
+LIBS := -package lwt,tyxml,ssl,netstring-pcre,ipaddr \
         ${addprefix -I ../src/, baselib http server extensions }
 
 doc: api-html/index.html

=== src/Makefile ===
--- 
+++ 
@@ -64,6 +64,7 @@
 	  > $@
 
 ../local/etc/$(PROJECTNAME).conf: files/${PROJECTNAME}.conf.in ../Makefile.config Makefile
+	mkdir -p ../local/etc ../local/var/log ../local/var/run
 	cat $< \
 	  | sed s%80\</port\>%8080\</port\>%g \
 	  | sed s%_LOGDIR_%$(SRC)/local/var/log%g \

=== src/baselib/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../../Makefile.config
 
-LIBS     := -package lwt.unix,netstring,cryptokit,findlib,tyxml,lwt.syntax,${LWT_EXTRA_PACKAGE}
+LIBS     := -package lwt.unix,netstring,netstring-pcre,cryptokit,findlib,tyxml,lwt.syntax,${LWT_EXTRA_PACKAGE},ipaddr
 OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
 OCAMLDOC := $(OCAMLFIND) ocamldoc

=== src/extensions/Makefile ===
--- 
+++ 
@@ -1,9 +1,11 @@
 include ../../Makefile.config
 
 PACKAGE  := lwt.unix     \
+			ipaddr       \
 	    lwt.ssl      \
 	    lwt.react    \
             netstring    \
+            netstring-pcre \
 	    tyxml.parser \
 
 LIBS     := -I ../baselib -I ../http -I ../server ${addprefix -package ,${PACKAGE}}

=== src/http/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../../Makefile.config
 
-LIBS     := -package netstring,lwt.ssl,tyxml -I ../baselib
+LIBS     := -package netstring,netstring-pcre,lwt.ssl,tyxml -I ../baselib
 OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
 OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
 OCAMLDOC := $(OCAMLFIND) ocamldoc

=== debian/changelog ===
ocsigenserver (2.4.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Thu, 26 Jun 2014 11:27:56 +0200

ocsigenserver (2.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Jun 2014 07:45:09 +0200

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
  libzip-ocaml-dev (>= 1.04-6~),
  libcryptokit-ocaml-dev (>= 1.3-14~),
  libtyxml-ocaml-dev (>= 2.2.0),
+ libipaddr-ocaml-dev,
  dh-ocaml (>= 0.9.5~)
 Standards-Version: 3.9.4
 Homepage: http://ocsigen.org/ocsigenserver/
